<?php
// $Id: subscriptions.admin.inc,v 1.1.2.11 2007/12/29 10:28:12 chx Exp $

/**
 * Admin settings
 */
function subscriptions_settings_form() {
  $form['sub_settings'] = array(
      '#type' => 'fieldset',
      '#title' => t('General settings'),
      '#weight' => -10,
  );
  $form['sub_settings']['subscriptions_watchgood'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Display watchdog entries for successful mailings'),
    '#default_value' => variable_get('subscriptions_watchgood', 1),
    '#description'   => t('Inserts notification of successful mailings in the watchdog log.  Default is ON.'),
  );
  //$form['sub_settings']['subscriptions_testpost'] = array(
  //  '#type'          => 'checkbox',
  //  '#title'         => t('Test held posts prior to sending'),
  //  '#default_value' => variable_get('subscriptions_testpost', 0),
  //  '#description'   => t('Tests to see if a post about to be sent by cron is still active.  Adds a small amount of overhead.  Default is OFF.'),
  //);
  //$form['sub_settings']['subscriptions_link_teaser'] = array(
  //  '#type'          => 'checkbox',
  //  '#title'         => t('Show subscribe link with teaser'),
  //  '#default_value' => variable_get('subscriptions_link_teaser', 1),
  //  '#description'   => t('Uncheck to show link only in node view.'),
  //);

  return system_settings_form($form);
}

/* ******************************************************* */
/*  user screens: display, edit functions                  */
/* ******************************************************* */

function theme_subscriptions_form_table($element) {
  $output = '';
  $rows = array();
  $header = array(
    array('data' => '&nbsp;', 'width' => '20%'),
    array('data' => t('Send interval'), 'width' => '20%'), 
    array('data' => t('On updates'), 'width' => '20%'));
  
  // check whether we have an On comments column
  if (module_exists('comment'))
  {
    $show_on_comments = TRUE;
    $header[] = array('data' => t('On comments'), 'width' => '20%');
  }

  // check whether we have an Author column
  if (isset($element['author'])) {
    foreach (element_children($element['checkboxes']) as $key) {
      foreach (element_children($element['checkboxes'][$key]) as $key1) {
        if ($key1 != -1) {
          $show_author = TRUE;
        }
      }
    }
    if ($show_author) {
      $header[] = array('data' => t('Author'), 'width' => '20%');
    }
  }
  $header[count($header)-1]['width'] = '';  // let the last column grow
  
  foreach (element_children($element['checkboxes']) as $key) {
    foreach (element_children($element['checkboxes'][$key]) as $key1) {
      $row = array(
        drupal_render($element['checkboxes'][$key][$key1]),
        drupal_render($element['selects'][$key][$key1]),
        drupal_render($element['send_updates'][$key][$key1]),
      );
      if ($show_on_comments) {
        $row[] = drupal_render($element['send_comments'][$key][$key1]);
      }
      if ($show_author) {
        $row[] = drupal_render($element['author'][$key][$key1]);
      }
      $rows[] = $row;
    }
  }
  if ($rows) {
    $output .= theme('table', $header, $rows);
    $output .= drupal_render($element);
  }
  return $output;
}


function subscriptions_page_form_submit($form_id, $form_values) {
  global $user;
  $rid0 = current($form_values['roles']);
  if ($form_values['op'] == $form_values['submit']) {
    if (!isset($form_values['roles'])) {
      $form_values['roles'][] = -$form_values['uid'];  // will be negated again below 
    }
    $module = $form_values['module'];
    $field = $form_values['field'];
    foreach ($form_values as $element_values) {
      if (isset($element_values['defaults']['selects'])) {
        $defaults = $element_values['defaults'];
        foreach ($element_values['checkboxes'] as $value => $bundle) {
          foreach ($bundle as $author_uid => $set_to_enabled) {
            if ($set_to_enabled && (
                !isset($defaults['checkboxes'][$value][$author_uid]) ||
                $element_values['selects'][$value][$author_uid] != $defaults['selects'][$value][$author_uid] ||
                $element_values['send_updates'][$value][$author_uid] != $defaults['send_updates'][$value][$author_uid] ||
                $element_values['send_comments'][$value][$author_uid] != $defaults['send_comments'][$value][$author_uid])) {
              $send_updates = ($element_values['send_updates'][$value][$author_uid] ? 1 : 0);
              $send_comments = ($element_values['send_comments'][$value][$author_uid] ? 1 : 0);
              foreach ($form_values['roles'] as $uid) {
                subscriptions_write($module, $field, $value, $author_uid, -$uid, $element_values['selects'][$value][$author_uid], $send_updates, $send_comments);
              }
              drupal_set_message(t('Your subscription was activated.'));
            }
            elseif (!$set_to_enabled && isset($defaults['checkboxes'][$value][$author_uid])) {
              // It was enabled but now it is not. Delete.
              foreach ($form_values['roles'] as $uid) {
                db_query("DELETE FROM {subscriptions} WHERE module = '%s' AND field = '%s' AND value = %d AND author_uid = %d AND recipient_uid = %d", $module, $field, $value, $author_uid, -$uid);
              }
              drupal_set_message(t('Your subscription was deactivated.'));
            }
          }
        }
      }
    }
  }
  if ($rid0) {
    drupal_goto('admin/settings/subscriptions/userdefaults/'. arg(4) .'/'. $rid0);
  }
}

/**
 * displays subscribed content data on user and subscription pages
 * @ TODO clean up all of these parts
 */
function subscriptions_page($account, $stype) {
  $stypes = subscriptions_types();
  if (!isset($stypes[$stype])) {
    drupal_not_found();
    return;
  }
  
  $form['header'] = array(
    '#value'         => (arg(0) == 'admin' ? t('The selected subscriptions will be given to newly created users:') : t('Current subscriptions:')),
    '#weight'        => -2,
    );
  if (arg(0) == 'admin') {
    $form['role'] = array(
      '#type'        => 'fieldset',
      '#title'       => t('Roles'),
      '#weight'      => -1,
      '#collapsible' => TRUE,
      '#collapsed'   => !is_numeric(arg(5)),
      );
    $form['role']['header'] = array(
      '#type'          => 'markup',
      '#value'         => '<div>'. t('If a user has one or more roles assigned at creation time, then she will receive the additional subscriptions defined for these roles.') .'</div>',
      '#weight'        => -5,      
      );
    $form['role']['roles'] = array(
      '#type'          => 'select',
      '#title'         => t('Role(s)'),
      '#default_value' => (is_numeric(arg(5))? arg(5) : DRUPAL_AUTHENTICATED_RID),
      '#options'       => user_roles(TRUE),
      '#description'   => t('Select the role to load or role(s) to save.'),
      '#multiple'      => TRUE,
      );   
    $form['role']['load'] = array(
      '#type'          => 'submit',
      '#value'         => t('Load'),
      );
  }
  
  $callback = $stypes[$stype]['page'];
  $output = function_exists($callback) ? $output . $callback($account, $form) : '';
  //drupal_add_link(array(
  //  'rel' => 'alternate',
  //  'type' => 'application/rss+xml',
  //  'title' => t("!name Subscriptions", array('!name' => $user->name)),
  //  'href' => url('subscriptions/feed'),
  //));
  drupal_set_title(isset($account) ? check_plain($account->name) : t('Subscriptions'));
  return theme('box', '', $output); // . theme('xml_icon', url("subscriptions/feed"));
}

function subscriptions_page_user_overview($account) {
  // Build summary
  $uid = (isset($account) ? $account->uid : -DRUPAL_AUTHENTICATED_RID);
  $count = array();
  $result = db_query("SELECT module, field, count(1) as number FROM {subscriptions} WHERE recipient_uid = %d GROUP BY module, field", $uid);
  while ($subs = db_fetch_object($result)) {
    $count[$subs->module][$subs->field] = $subs->number;
  }
  // blog is a subtype of 'type' -- must do it separately
  $count['blog']['author_uid'] = db_result(db_query("SELECT count(*) FROM {subscriptions} WHERE module = 'node' AND field = 'type' AND value = 'blog' AND recipient_uid = %d", $uid));
  
  $header = array(t('Type'), t('Number'));
  $types = subscriptions_types();
  if ($uid < 0) {
    unset($types['node']);
  }
  uasort($types, _subscriptions_cmp_by_weight);
  foreach ($types as $stype => $type) {
    $has_access = ($uid < 0 && user_access('administer site configuration')) || user_access($type['access'], $account);
    if ($has_access || user_access('administer user subscriptions')) {
      $rows[] = array(
        ($has_access ? l($type['title'], ($uid < 0 ? "admin/settings/subscriptions/userdefaults/$stype" : "user/$account->uid/subscriptions/$stype")) : $type['title']),
        isset($count[$type['fields'][0]][$type['fields'][1]]) ? $count[$type['fields'][0]][$type['fields'][1]] : 0,
      );
    }
  }
  $output .= theme('table', $header, $rows);
  $output .= '<br />';

  $output .= drupal_get_form(subscriptions_user_settings_form, $account);
  drupal_set_title($uid < 0 ? t('Subscriptions') : check_plain($account->name));
  return $output;
}

function subscriptions_user_settings_form($account)
{
  $uid = (isset($account) ? $account->uid : -DRUPAL_AUTHENTICATED_RID);
  $form['settings'] = array(
    '#type'          => 'fieldset',
    '#title'         => t('Settings'),
    '#weight'        => 5,
    '#collapsible'   => isset($account),
    '#collapsed'     => isset($account),
    );
  if ($uid < 0) {
    $form['settings']['info'] = array(
      '#value'       => t("These settings are used by those users that haven't (yet) saved their own settings."),
    );
  }
  $form['settings']['subscriptions_autoset'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Auto-subscribe'),
    '#default_value' => _subscriptions_get_setting('auto_sub', $account),
    '#description'   => t('Automatically subscribes you to items that you create, update, or comment on.'),
  );
  $form['settings']['subscriptions_sendself'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Notify poster of own posts'),
    '#default_value' => _subscriptions_get_setting('send_self', $account),
    '#description'   => t("Sends you notifications about your own posts."),
  );
  $form['settings']['defaults'] = array(
    '#type'          => 'fieldset',
    '#title'         => t('Defaults'),
  );
  $form['settings']['defaults']['send_interval'] = array(
    '#title'         => t('Send interval'),
    '#type'          => 'select',
    '#options'       => _subscriptions_send_intervals(),
    '#default_value' => _subscriptions_get_setting('send_interval', $account),
    '#description'   => t('The frequency of notifications; it may take longer, but notifications will not be sent more frequently than indicated.'),
  );
  $form['settings']['defaults']['send_updates'] = array(
    '#title'         => t('On updates'),
    '#type'          => 'checkbox',
    '#default_value' => _subscriptions_get_setting('send_updates', $account),
    '#description'   => t('Sends a notification when an item is updated.'),
  );
  $form['settings']['defaults']['send_comments'] = array(
    '#title'         => t('On comments'),
    '#type'          => 'checkbox',
    '#default_value' => _subscriptions_get_setting('send_comments', $account),
    '#description'   => t('Sends a notification when an item receives a comment or reply.'),
  );
  $form['settings']['save'] = array(
    '#type'          => 'submit',
    '#value'         => t('Save'),
  );
  if ($uid > 0) {
    $form['settings']['reset'] = array(
      '#type'        => 'submit',
      '#value'       => t('Reset to site defaults'),
    );
  }
  $form['settings']['#submit']['subscriptions_user_options_submit'] = array();
  return $form;
}

function subscriptions_user_settings_form_submit($form_id, $form_values) {
  if ($form_values['op'] == $form_values['reset']) {
    $account = user_load(array('uid' => arg(1)));
    if (isset($account)) {
      user_save($account, array('subscriptions_auto' => NULL));
      user_save($account, array('subscriptions_sendself' => NULL));
      $uid = $account->uid;
      db_query("UPDATE {subscriptions_user} SET send_interval = -1, send_updates = -1, send_comments = -1 WHERE uid = %d", $uid);
      drupal_set_message(t('The site defaults were restored.'));
    }
  }
  else
  {
    if (arg(0) == 'user') {
      $account = user_load(array('uid' => arg(1)));
      if (isset($account)) {
        user_save($account, array('subscriptions_auto' => $form_values['subscriptions_autoset']));
        user_save($account, array('subscriptions_sendself' => $form_values['subscriptions_sendself']));
      }
      $uid = $account->uid;
    }
    else {
      variable_set('subscriptions_autoset', $form_values['subscriptions_autoset']);
      variable_set('subscriptions_sendself', $form_values['subscriptions_sendself']);
      $uid = -DRUPAL_AUTHENTICATED_RID;
    }
    db_query("UPDATE {subscriptions_user} SET send_interval = %d, send_updates = %d, send_comments = %d WHERE uid = %d", $form_values['send_interval'], $form_values['send_updates'], $form_values['send_comments'], $uid);
    drupal_set_message(t('The changes have been saved.'));
  }
}

function subscriptions_intervals() {
  $default = '';
  foreach (_subscriptions_send_intervals() as $interval => $text) {
    $default .= "$interval|$text\n";
  }
  $form['intervals'] = array(
    '#type' => 'textarea',
    '#cols' => 40,
    '#default_value' => $default,
    '#description' => t('Every line has the format of seconds|human readable text'),
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );
  return $form;
}

function subscriptions_intervals_submit($form_id, $form_values) {
  $intervals = array();
  foreach (explode("\n", $form_values['intervals']) as $line) {
    if ($line) {
      $v = explode('|', $line);
      $intervals[$v[0]] = $v[1];
    }
  }
  variable_set('subscriptions_send_intervals', $intervals);
}

function subscriptions_add_form($stype, $sid, $uid = NULL) {
  global $user;
  $form['sid'] = array('#type' => 'value', '#value' => $sid);
  $form['uid'] = array('#type' => 'value', '#value' => isset($uid) ? $uid : $user->uid);
  $form['stype'] = array('#type' => 'value', '#value' => $stype);
  $form['send_interval'] = array(
    '#title' => t('Send interval'),
    '#type' => 'select',
    '#options' => _subscriptions_send_intervals(),
    '#default_value' => 1,
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Subscribe'),
  );
  return $form;
}

function subscriptions_add_form_submit($form_id, $form_values) {
  if ($a = module_invoke_all('subscriptions', 'stype', $form_values['stype'])) {
    list($module, $field) = $a;
  }
  subscriptions_write_subscription($module, $field, $form_values['sid'], $form_values['uid'], $form_values['send_interval']);
  drupal_set_message(t('Your subscription was activated.'));
}

/**
 * List of send intervals
 */
function _subscriptions_send_intervals() {
  return variable_get('subscriptions_send_intervals',
    array(
      1 => t('As soon as possible'),
      900 => t('Every 15 minutes'),
      3600 => t('Hourly'),
      10800 => t('Every three hours'),
      86400 => t('Daily'),
    )
  );
}

function subscriptions_form_helper(&$form, &$defaults, $author_uid, $key, $title, $subscription) {
  static $intervals;
  if (!isset($intervals)) {
    $intervals = _subscriptions_send_intervals();
  }
  if (($author_uid == $subscription['author_uid'])) {
    $defaults['checkboxes'][$key][$author_uid] = 1;
  }
  $defaults['selects'][$key][$author_uid] = $subscription['send_interval'];
  if ($subscription['send_comments']) {
    $defaults['send_comments'][$key][$author_uid] = 1;
  }
  if ($subscription['send_updates']) {
    $defaults['send_updates'][$key][$author_uid] = 1;
  }
  if ($subscription['author_uid'] > 0) {
    $author_value = check_plain(db_result(db_query('SELECT name FROM {users} WHERE uid = %d', $subscription['author_uid'])));
  }
  else {
    $author_value = '';
  }
  $form['author'][$key][$author_uid] = array(
    '#value' => $author_value,
  );
  $form['selects'][$key][$author_uid] = array(
    '#type' => 'select',
    '#options' => $intervals,
    '#default_value' => $defaults['selects'][$key][$author_uid],
  );
  foreach (array('checkboxes', 'send_comments', 'send_updates') as $index => $name) {
    $form[$name][$key][$author_uid] = array(
      '#type' => 'checkbox',
      '#title' => $index ? '' : $title,
      '#default_value' => $defaults[$name][$key][$author_uid],
    );
  }
}
